#include <memory>
#include <type_traits>
#include <utility>

struct base { };
struct derived : base { };

derived *func() { return 0; }

struct target { };
typedef target *cvt_type;
struct source {
  operator cvt_type() { return static_cast<cvt_type>(0); }
};

// x
struct any_source {
  template <class T>
  operator T() const { return T(); }
};

// y
struct any_ptr_source {
  template <class T>
  operator T*() const { return 0; }
};

// g
template <class T>
struct generic_source {
  operator T() const { return T(); }
};

// w
template <class T>
struct ptr {
  T* ptr_;
  ptr(T* p = 0) : ptr_(p) { }
  bool operator != (decltype(nullptr)) { return ptr_ != static_cast<T*>(0); }

  // ptr<derived> is implicitly convertible to ptr<base> but not the
  // other way around.
  template <
      class U,
      class = typename std::enable_if<std::is_base_of<T, U>::value>::type>
  ptr(ptr<U>) {}
};

// n
template <class T>
struct deleter {
  typedef ptr<T> pointer;

  void operator()(ptr<T>) const {}
};

template <typename T>
struct my_type_is {
  my_type_is();
};

template <typename T>
my_type_is<T>::my_type_is() { }

template <bool V>
struct my_value_is {
  my_value_is();
};

template <bool V>
my_value_is<V>::my_value_is() { }
