#!/bin/sh

OLD="g++ -g0 -S -std=c++0x"
NEW="/mnt/sdc1/crowl/trunk/bld3/gcc/xg++"
NEW="$NEW -g0 -S -std=c++11"
NEW="$NEW -fno-diagnostics-show-caret"
NEW="$NEW -fmessage-length=0"
NEW="$NEW -fuse-linker-plugin"
NEW="$NEW -flto"
NEW="$NEW -nostdinc++"
NEW="$NEW -I/mnt/sdc1/crowl/trunk/bld3/x86_64-unknown-linux-gnu/libstdc++-v3/include/x86_64-unknown-linux-gnu"
NEW="$NEW -I/mnt/sdc1/crowl/trunk/bld3/x86_64-unknown-linux-gnu/libstdc++-v3/include"
NEW="$NEW -I/mnt/sdc1/crowl/trunk/src3/libstdc++-v3/libsupc++"
NEW="$NEW -I/mnt/sdc1/crowl/trunk/src3/libstdc++-v3/include/backward"
NEW="$NEW -I/mnt/sdc1/crowl/trunk/src3/libstdc++-v3/testsuite/util"
NEW="$NEW -B/mnt/sdc1/crowl/trunk/bld3/gcc/"
NEW="$NEW -B/mnt/sdc1/crowl/trunk/bld3/x86_64-unknown-linux-gnu/./libstdc++-v3/src/.libs"
NEW="$NEW -L/mnt/sdc1/crowl/trunk/bld3/x86_64-unknown-linux-gnu/libstdc++-v3/src/.libs"

just_compile()
{
  $NEW $1
}

report_errors()
{
  $OLD $1 > $1.err0 2>&1
  $NEW $1 > $1.err1 2>&1
  err0=` grep -c " error: " $1.err0 `
  err1=` grep -c " error: " $1.err1 `
  echo "$t has $err0 and $err1 errors"
}

report_files()
{
  for t in $*
  do
    report_errors $t
  done
}

echo
echo "expecting no errors in both compilers"
echo
report_files test_cb_pb.cc test_vb_pb.cc test_cvb_pb.cc
report_files test_pcb_ab.cc test_pcvb_ab.cc test_pvb_ab.cc
report_files test_anb_pb.cc

echo
echo "expecting errors only in old compiler"
echo

report_files test_acb_ab.cc test_avb_ab.cc test_acvb_ab.cc
report_files test_anb_nb.cc

echo
echo "expecting errors only in old compiler when exact user conversion allowed"
echo

report_files test_at_s.cc test_act_s.cc test_avt_s.cc test_acvt_s.cc
report_files test_ab_y.cc test_acb_y.cc test_avb_y.cc test_acvb_y.cc
report_files test_ab_gpb.cc test_acb_gpb.cc test_avb_gpb.cc test_acvb_gpb.cc

echo
echo "expecting errors in both compilers when inexact user conversion disallowed"
echo

report_files test_ab_gpd.cc test_acb_gpd.cc test_avb_gpd.cc test_acvb_gpd.cc
report_files test_anb_nd.cc test_anb_pd.cc

echo
echo "expecting errors in both compilers"
echo

report_files up.cc test_cb_ad1.cc test_cb_ad2.cc
report_files test_acb_ad.cc test_avb_ad.cc test_acvb_ad.cc
report_files test_ab_x.cc test_acb_x.cc test_avb_x.cc test_acvb_x.cc
report_files test_ab_pd.cc test_acb_pd.cc test_avb_pd.cc test_acvb_pd.cc
report_files test_ab_fpd.cc test_acb_fpd.cc test_avb_fpd.cc test_acvb_fpd.cc

